﻿--[[
    Name:           Titan MinimapControls
	Description:	Titan Panel plugin to replace the standard minimap buttons
    Author:         Suddendeath2000
    Version:        3.3.3
    --]]

MCID = "MinimapControls"
MCVersion = "3.3.3"
MCC1 = "|cffffffff"
MCC2 = "|cff993300"
MCC3 = "|cff00ff00"
MCC4 = "|cffffffcc"
MCC5 = "|cffffcc00"
MCC6 = "|cff990099"
MCC7 = "|cffff0000"
MCC8 = "|cff99cc99"
TitanPanelMC = "Minimap Buttons"
ShowMinimapCluster = true
ShowMinimapButtons = true
ShowMinimapWorldMap = true
ShowMinimapTracking = true
ShowMinimapZoom = true
ShowMinimapZone = true
ShowMinimapNorthTag = true           
ShowMinimapTime = true
ShowMinimapGameTime = true
ShowMinimapVoiceChat = true
ShowMinimapMail = true
ShowMinimapBattlefield = true
ShowMinimapLFD = true

function TitanPanelMinimapControlsButton_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(MCC1.."Titan Panel "..MCC2.."["..MCID.."] "..MCC1.."v"..MCC2..MCVersion.." "..MCC1.."by |cff999999Suddendeath2000")
   
    this:RegisterEvent("ADDON_LOADED")   
    
    self.registry = {
		id = MCID,
	    version = MCVersion,
        menuText = MCID,
        buttonTextFunction = "TitanPanelMinimapControlsButton_GetButtonText",	
        category = "General",
        tooltipTitle = MCC5..MCID,
		tooltipTextFunction = "TitanPanelMinimapControlButton_GetTooltipText",
        iconButtonWidth = 16,
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,  
            ShowTooltipText = 1,
            ShowMenuOptions = 1,
            ShowAdvancedMenus = 1,
            }}
end

function TitanPanelMinimapControlsButton_GetButtonText()
    local Button = TitanUtils_GetButton("MinimapControls", true)    
    local hour, minute = GetGameTime()
     Button.registry.icon = GetTrackingTexture()
      if sender1 == nil then MailIcon = ""        
          elseif sender1 then
            if (sender1 or sender2 or sender3):match("Customer Service") then MailIcon = MCC6.."Blizz Mail!! "
              else MailIcon = "|cffffffccMail! "
    end
  end
    if IsVoiceChatEnabled() then VCIcon = MCC8.."<VC> "
      else VCIcon = ""
  end
    if GetLFGMode() == "lfgparty" then DFIcon = MCC7.."InDungeon/Raid"
      elseif GetLFGMode() ~= nil and GetLFGMode() ~= "abandonedInDungeon" then DFIcon = MCC7.."InDungeon/RaidQueue "
        else DFIcon = ""
  end      
  
    for i=1, MAX_BATTLEFIELD_QUEUES do
	  BFstatus, _, _, _, _, _, _ = GetBattlefieldStatus(i)
    if ( BFstatus == "queued" or BFstatus == "confirm" ) then BFIcon = MCC7.."InBattlefieldQueue "
        elseif BFstatus == "active" then BFIcon = MCC7.."InBattlefield "
          else BFIcon = ""
  end  
        if ShowRealmTime == true then return "MinimapControls: "..VCIcon..BFIcon..DFIcon..MailIcon..MCC3..GameTime_GetFormattedTime(hour, minute, wantAMPM)
          else return "MinimapControls "..VCIcon..BFIcon..DFIcon..MailIcon      
    end
  end
end


function TitanPanelMinimapControlButton_GetTooltipText()    
    return MCC3.."Right-click to Open Menu\r"..MCC3.."Shift/Double Left-click to Open WorldMap\r"..MCC3.."Control/Double Left-click to Zoom In\r"..MCC3.."Alt/Double Left-click to Zoom Out"
end
 

function TitanPanelMinimapControls_OnDoubleClick(button)
    if IsShiftKeyDown() and button == "LeftButton" then ToggleFrame(WorldMapFrame)
      elseif IsControlKeyDown() and button == "LeftButton" then TitanPanelMinimapControlsZoomIn()
        elseif IsAltKeyDown() and button == "LeftButton" then TitanPanelMinimapControlsZoomOut()
  end
end

function TitanPanelRightClickMenu_PrepareMinimapControlsMenu(button)
    local info = {}

    if  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelMC )then
      TitanPanelRightClickMenu_AddTitle(TitanPanelMC, UIDROPDOWNMENU_MENU_LEVEL)
    
        info.text = "World Map Button"
		info.func = function () TitanPanelMinimapControlsToggleWorldMap () end
        info.checked = ShowMinimapWorldMap == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Tracking Button"
		info.func = function () TitanPanelMinimapControlsToggleTrackingButton () end
        info.checked = ShowMinimapTracking == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Zoom Buttons"
		info.func = TitanPanelMinimapControlsToggleZoomButtons
        info.checked = ShowMinimapZoom == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Zone Text"
		info.func = TitanPanelMinimapControlsToggleZoneText
        info.checked = ShowMinimapZone == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Time/Calendar"
		info.func = TitanPanelMinimapControlsToggleTime
        info.checked = ShowMinimapTime == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Game Time"
		info.func = TitanPanelMinimapControlsToggleGameTime
        info.checked = ShowMinimapGameTime == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Voice Chat"
		info.func = TitanPanelMinimapControlsToggleVoiceChat
        info.checked = ShowMinimapVoiceChat == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Mail Display"
		info.func = TitanPanelMinimapControlsToggleMailDisplay
        info.checked = ShowMinimapMail == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Battlefield"
		info.func = TitanPanelMinimapControlsToggleBattlefield
        info.checked = ShowMinimapBattlefield == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = "Looking For Dungeon"
		info.func = TitanPanelMinimapControlsToggleLFD
        info.checked = ShowMinimapLFD == true
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    else
    
        TitanPanelRightClickMenu_AddTitle(MCID)
        TitanPanelRightClickMenu_AddSpacer()
       
        TitanPanelMinimapControlsMail()
        
        TitanPanelMinimapControlsBattlefield()
        
        TitanPanelMinimapControlsLFD()
        
        TitanPanelMinimapControlsVoice()

        MiniMapTrackingDropDown_Initialize()
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info.text = "Show Clock"
		info.func = TitanPanelMinimapControlsToggleClock       
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
		info.text = "Show Calendar"
		info.func = function () ToggleCalendar() end        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info.text = "Show Minimap Buttons"
        info.func = nil
        info.value = TitanPanelMC
        info.checked = nil
        info.hasArrow = 1		
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info.text = "Show Minimap"
		info.func = TitanPanelMinimapControlsToggleMinimapCluster
        info.checked = ShowMinimapCluster == true
        info.hasArrow = nil
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
		info.text = "Show Realm Time"
		info.func = TitanPanelMinimapControlsToggleRealmTime
        info.checked = ShowRealmTime == true
        info.hasArrow = nil
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddToggleIcon(MCID)
  end
end

function TitanPanelMinimapControlsZoomIn()
    MinimapZoomOut:Enable()
	Minimap:SetZoom(Minimap:GetZoom() + 1)
	if(Minimap:GetZoom() == (Minimap:GetZoomLevels() - 1)) then MinimapZoomIn:Disable()
	end
end

function TitanPanelMinimapControlsZoomOut()
    MinimapZoomIn:Enable()	
	Minimap:SetZoom(Minimap:GetZoom() - 1)
	if(Minimap:GetZoom() == 0) then MinimapZoomOut:Disable()
	end
end

function TitanPanelMinimapControlsToggleRealmTime()
    if ShowRealmTime == true then ShowRealmTime = false 
      else ShowRealmTime = true
  end
end

function TitanPanelMinimapControlsMail()
    if sender1 then TitanPanelRightClickMenu_AddTitle("Unread Mail From:")
      end
    if sender1 then TitanPanelRightClickMenu_AddTitle(MCC4..sender1)
      end
    if sender2 then TitanPanelRightClickMenu_AddTitle(MCC4..sender2)
      end
    if sender3 then TitanPanelRightClickMenu_AddTitle(MCC4..sender3)
      end
    if sender1 then TitanPanelRightClickMenu_AddSpacer()
  end
end

function TitanPanelMinimapControlsBattlefield()
    for i=1, MAX_BATTLEFIELD_QUEUES do
	  BFstatus, _, _, _, _, _, _ = GetBattlefieldStatus(i)
    if BFstatus ~= "none" then 
      TitanPanelMinimapControlsMiniMapBattlefieldDropDown()
      TitanPanelRightClickMenu_AddSpacer()
    end
  end
end

function TitanPanelMinimapControlsLFD()
    if GetLFGMode() ~= nil then
      TitanPanelRightClickMenu_AddTitle(MCC5.."Dungeon Finder/Raid Browser")
    
      info = {}
      info.text = "Open Dungeon Finder"
	  info.func = function () ToggleLFDParentFrame() end    
	  UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
      
      info = {}
      info.text = "Open Raid Browser"
	  info.func = function () ToggleLFRParentFrame() end
	  UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
      info = {}
      info.text = "Leave Queue"
	  info.func = function () LeaveLFG() end      
	  UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
      
      TitanPanelRightClickMenu_AddSpacer()
  end
end

function TitanPanelMinimapControlsVoice()
    if IsVoiceChatEnabled() then 
      info = {}
      info.text = "Chat Channels"
      info.icon = "Interface\\COMMON\\VOICECHAT-SPEAKER"
      info.func = function () ToggleFriendsFrame(4) end 
	  UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)      
      TitanPanelRightClickMenu_AddSpacer()
  end
end

function TitanPanelMinimapControls_OnEvent(event, arg1)
    if event == "ADDON_LOADED" and arg1 == "TitanMinimapControls" then
      if ShowMinimapCluster == false then MinimapCluster:Hide()
        elseif ShowMinimapCluster == true then MinimapCluster:Show()
  end 
    if ShowMinimapWorldMap == false then MiniMapWorldMapButton:Hide()
      elseif ShowMinimapWorldMap == true then MiniMapWorldMapButton:Show()
  end
    if ShowMinimapTracking == false then MiniMapTracking:Hide()     
      elseif ShowMinimapTracking == true then MiniMapTracking:Show()
  end
    if ShowMinimapZoom == false then MinimapZoomIn:Hide()
                                     MinimapZoomOut:Hide()
      elseif ShowMinimapZoom == true then MinimapZoomIn:Show()
                                          MinimapZoomOut:Show()
  end
    if ShowMinimapZone == false then MinimapBorderTop:Hide()
		                             MinimapZoneTextButton:Hide()
      elseif ShowMinimapZone == true then MinimapBorderTop:Show()
		                                  MinimapZoneTextButton:Show()
  end    
    if ShowMinimapTime == false then GameTimeFrame:Hide()
      elseif ShowMinimapTime == true then GameTimeFrame:Show()
  end
    if ShowMinimapVoiceChat == false then MiniMapVoiceChatFrame:Hide()
      elseif ShowMinimapVoiceChat == true then MiniMapVoiceChatFrame:Show()
  end
    if ShowMinimapMail == false then MiniMapMailFrame:Show()
      elseif ShowMinimapMail == true and sender1 then MiniMapMailFrame:Hide()
    end    
  end
end

function TitanPanelMinimapControlsToggleClock()
    if TimeManagerFrame:IsVisible() then TimeManagerFrame:Hide()
      else TimeManagerFrame:Show()
  end
    
end

function TitanPanelMinimapControlsToggleMinimapCluster()
    if ShowMinimapCluster == true then ShowMinimapCluster = false 
      else ShowMinimapCluster = true
  end     
end

function TitanPanelMinimapControlsToggleWorldMap()
    if ShowMinimapWorldMap == true then ShowMinimapWorldMap = false
      else ShowMinimapWorldMap = true
  end    
end

function TitanPanelMinimapControlsToggleTrackingButton()
    if ShowMinimapTracking == true then ShowMinimapTracking = false                                       
      else ShowMinimapTracking = true           
  end    
end

function TitanPanelMinimapControlsToggleZoomButtons()
    if ShowMinimapZoom == true then ShowMinimapZoom = false                                       
      else ShowMinimapZoom = true
  end    
end

function TitanPanelMinimapControlsToggleZoneText()
    if ShowMinimapZone == true then ShowMinimapZone = false                                       
      else ShowMinimapZone = true
  end   
end

function TitanPanelMinimapControlsToggleTime()
    if ShowMinimapTime == true then ShowMinimapTime = false                                       
      else ShowMinimapTime = true
  end    
end

function TitanPanelMinimapControlsToggleGameTime()
    if ShowMinimapGameTime == true then ShowMinimapGameTime = false                                       
      else ShowMinimapGameTime = true           
  end    
end

function TitanPanelMinimapControlsToggleVoiceChat()
    if ShowMinimapVoiceChat == true then ShowMinimapVoiceChat = false                                       
      else ShowMinimapVoiceChat = true           
  end    
end

function TitanPanelMinimapControlsToggleMailDisplay()
    if ShowMinimapMail == true then ShowMinimapMail = false                              
      else ShowMinimapMail = true     
  end    
end

function TitanPanelMinimapControlsToggleBattlefield()    
    if ShowMinimapBattlefield == true then ShowMinimapBattlefield = false                                       
      else ShowMinimapBattlefield = true           
  end    
end

function TitanPanelMinimapControlsToggleLFD()
    if ShowMinimapLFD == true then ShowMinimapLFD = false                                       
      else ShowMinimapLFD = true
  end    
end

function TitanPanelMinimapControlsMiniMapBattlefieldDropDown()
	local info
	local status, mapName, instanceID, levelRangeMin, levelRangeMax, teamSize, registeredMatch
	local numQueued = 0
	local numShown = 0
	
	if ( CanHearthAndResurrectFromArea() ) then
	  numShown = numShown + 1
	    info = UIDropDownMenu_CreateInfo()
	    info.text = GetRealZoneText()
	    info.isTitle = 1
	    info.notCheckable = 1
	    UIDropDownMenu_AddButton(info)

	    info = UIDropDownMenu_CreateInfo()
	    info.text = format(LEAVE_ZONE, GetRealZoneText())		
		
	    info.func = HearthAndResurrectFromArea
	    info.notCheckable = 1
	    UIDropDownMenu_AddButton(info)
  end
		
	for i=1, MAX_BATTLEFIELD_QUEUES do
	  status, mapName, instanceID, levelRangeMin, levelRangeMax, teamSize, registeredMatch = GetBattlefieldStatus(i)

	if ( status ~= "none" ) then numShown = numShown + 1
	if ( numShown > 1 ) then
	    info = UIDropDownMenu_CreateInfo()
	    info.isTitle = 1
	    info.notCheckable = 1
	    UIDropDownMenu_AddButton(info)
	end
  end

	if ( status == "queued" or status == "confirm" ) then numQueued = numQueued + 1	

	    info = UIDropDownMenu_CreateInfo()
	if ( teamSize ~= 0 ) then
	  if ( registeredMatch ) then info.text = ARENA_RATED_MATCH.." "..format(PVP_TEAMSIZE, teamSize, teamSize)
	    else info.text = ARENA_CASUAL.." "..format(PVP_TEAMSIZE, teamSize, teamSize)
				end
		else info.text = "       "..mapName
  end
	    info.isTitle = 1
	    info.notCheckable = 1
	    UIDropDownMenu_AddButton(info)		

	if ( status == "queued" ) then
      if ( teamSize == 0 ) then
	    info = UIDropDownMenu_CreateInfo()
		info.text = "       "..CHANGE_INSTANCE
		info.func = function(self, ...) ShowBattlefieldList(...) end
		info.arg1 = i
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)
  end

		info = UIDropDownMenu_CreateInfo()
		info.text = "       "..LEAVE_QUEUE
		info.func = function (self, ...) AcceptBattlefieldPort(...) end
		info.arg1 = i
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)

	  elseif ( status == "confirm" ) then

		info = UIDropDownMenu_CreateInfo()
		info.text = "       "..ENTER_BATTLE
		info.func = function (self, ...) AcceptBattlefieldPort(...) end
		info.arg1 = i
		info.arg2 = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)

	if ( teamSize == 0 ) then
		info = UIDropDownMenu_CreateInfo()
		info.text = "       "..LEAVE_QUEUE
		info.func = function (self, ...) AcceptBattlefieldPort(...) end
		info.arg1 = i
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)
    end
  end			

	elseif ( status == "active" ) then info = UIDropDownMenu_CreateInfo()
	  if ( teamSize ~= 0 ) then
	    info.text = "       "..mapName.." "..format(PVP_TEAMSIZE, teamSize, teamSize)
		else
		info.text = "       "..mapName
  end
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)

		info = UIDropDownMenu_CreateInfo()
	if ( IsActiveBattlefieldArena() ) then
		info.text = "       "..LEAVE_ARENA
	  else
		info.text = "       "..LEAVE_BATTLEGROUND				
  end
		info.func = function (self, ...) LeaveBattlefield(...) end
	    info.notCheckable = 1
		UIDropDownMenu_AddButton(info)
	end
  end
end

function TitanPanelMinimapControlsButton_OnUpdate()
    local status
    for i=1, MAX_BATTLEFIELD_QUEUES do
	  status, _, _, _, _, _, _ = GetBattlefieldStatus(i)
  end
    if ShowMinimapBattlefield == false then MiniMapBattlefieldFrame:Hide()
      elseif ShowMinimapBattlefield == true and status ~= "none" then MiniMapBattlefieldFrame:Show()
  end
    sender1,sender2,sender3 = GetLatestThreeSenders()
    if ShowMinimapMail == false then MiniMapMailFrame:Hide()
      elseif ShowMinimapMail == true and sender1 then MiniMapMailFrame:Hide()
  end    
    if ShowMinimapVoiceChat == true and IsVoiceChatEnabled() then MiniMapVoiceChatFrame:Show()
      else MiniMapVoiceChatFrame:Hide()
  end    
    if ShowMinimapLFD == false then MiniMapLFGFrame:Hide()     
      elseif ShowMinimapLFD == true and GetLFGMode() ~= nil then MiniMapLFGFrame:Show()
  end    
    if TimeManagerClockButton:IsVisible() and ShowMinimapGameTime == false then TimeManagerClockButton:Hide()
      elseif ShowMinimapGameTime == true then TimeManagerClockButton:Show() 
  end
    if GameTimeFrame:IsVisible() and ShowMinimapTime == false then GameTimeFrame:Hide()
      elseif ShowMinimapTime == true then GameTimeFrame:Show()
  end
    if TimeManagerClockButton:IsVisible() and ShowMinimapGameTime == false then TimeManagerClockButton:Hide()
      elseif ShowMinimapGameTime == true then TimeManagerClockButton:Show()
  end
    if MinimapBorderTop:IsVisible() and ShowMinimapZone == false then MinimapBorderTop:Hide()
		                                                              MinimapZoneTextButton:Hide()
      elseif ShowMinimapZone == true then MinimapBorderTop:Show()
		                                  MinimapZoneTextButton:Show()
  end
    if MinimapZoomIn:IsVisible() and ShowMinimapZoom == false then MinimapZoomIn:Hide()
                                                                   MinimapZoomOut:Hide()
      elseif ShowMinimapZoom == true then MinimapZoomIn:Show()
                                          MinimapZoomOut:Show()
  end
    if MiniMapWorldMapButton:IsVisible() and ShowMinimapWorldMap == false then MiniMapWorldMapButton:Hide()
      elseif ShowMinimapWorldMap == true then MiniMapWorldMapButton:Show()
  end
    if MiniMapTracking:IsVisible() and ShowMinimapTracking == false then MiniMapTracking:Hide()     
      elseif ShowMinimapTracking == true then MiniMapTracking:Show()
  end
    if MinimapCluster:IsVisible() and ShowMinimapCluster == true then MinimapCluster:Show()
      else MinimapCluster:Hide()
  end   
  TitanPanelButton_UpdateButton(MCID)
end